.. Piveau-UI documentation master file, created by
   sphinx-quickstart on Tue Apr 24 15:05:53 2018.
   You can adapt this file completely to your liking, but it should at least
   contain the root `toctree` directive.

Piveau-UI
==========

.. toctree::
   :maxdepth: 2
   :caption: Contents:

Project Setup
=============

Install `Node.js and NPM <https://nodejs.org/en/>`_ on your system

Clone or download the `Piveau-UI repository <https://gitlab.fokus.fraunhofer.de/viaduct/piveau-ui>`_::

  $ git clone git@gitlab.fokus.fraunhofer.de/piveau/hub/piveau-hub-ui.git

Install NPM packages::

  $ cd piveau-ui
  $ npm install



user-config.js::
The user-config.js file is located at `piveau-ui/config/` by default. It is the main project configuration file. The following example file shortly describes the configurable values.

runtime-config.js
The `runtime-config.js` file is located at `piveau-ui/config/` by default. It is a template file, which lists all configurable environment variables that can be changed during runtime. See [Runtime Configurations](#runtime-configurations) for more information.

lang folder / i18n.js
The `lang` folder and `i18n.js` file are located at `piveau-ui/config/i18n/` by default. The `lang` folder contains translations for all available languages. The `i18n.js` imports all language files of the `lang` folder and exports them as one object.

UserImprint.vue / UserPrivacyPolicy.vue
The `UserImprint.vue` and `UserPrivacyPolicy.vue` files are located at `piveau-ui/src/components/user/`. They are more or less empty Vue components. Custom Imprint / PrivacyPolicy pages can be implemented here if no external pages are used (configurable in `user-config.js`).

e2e.js
The `e2e.js` file is located at `piveau-ui/config/` by default and is generated by the Vue-Webpack-Bundle. It contains several configurations for the development and production build process.

custom_theme.scss
The `custom-theme.scss` file is located at `piveau-ui/src/styles/` by default. It contains Bootstrap 4 SCSS variables and overrides the default Bootstrap values. It must be used to change any general styling rules like spacing, sizes, colors etc. It is also possible to add new color variables or other new variables, which can then be used via Bootstrap classes.



Build for development
=====================

Open a terminal in the `piveau-ui` directory and run:

    $ npm run dev

This will start a local webserver on Port `8080` (unless you defined a different port in `piveau-ui/config/e2e.js`).
Open a web browser and visit `http://localhost:8080` to see the app.
Hot Module Replacement is supported. The page will update automatically whenever files are changed and saved.


Build for Production
=====================

Open a terminal in the `piveau-ui` directory and run:

    $ npm run build

This will optimize files for production and store the bundle in `piveau-ui/dist`
Deploy the contents of `piveau-ui/dist` on your webserver.

..
  Indices and tables
  ==================

  * :ref:`genindex`
  * :ref:`modindex`
  * :ref:`search`
